/*
  test_1_libjlc.c
  Tests for the context 'libjlc'
 
  Copyright (c) 2006 James Ladd.
  http://www.hyperserve.org
  
  Please read the LICENSE file.
*/

#include <stdio.h>

#include "libjlc.h"    /* <- contains API documentation. */
#include "test.h"

jlc_uint shouldBeAbleToAttachToLibrary(jlc_lib* h) {

    printf("Should be able to attach to library");
    return jlc_lib_attach(h);
}

jlc_uint shouldBeAbleToDetachFromLibrary(jlc_lib* h) {

    printf("Should be able to detach from library");
    return jlc_lib_detach(h);
}

int main() {

    jlc_lib h;

    context("libjlc");
    if (shouldBeAbleToAttachToLibrary(&h) == 0) {

        passed();

        if (shouldBeAbleToDetachFromLibrary(&h) == 0) {

            return passed();
        }
    }

    return failed();
}

