/*
  test_2_libjlc.c
  Tests for the context 'libjlc thread pool'
 
  Copyright (c) 2006 James Ladd.
  http://www.hyperserve.org
  
  Please read the LICENSE file.
*/

#include <stdio.h>

#include "libjlc.h"    /* <- contains API documentation. */
#include "test.h"

jlc_uint shouldBeAbleToAttachToLibrary(jlc_lib* h) {

    printf("Should be able to attach to library");
    return jlc_lib_attach(h);
}

jlc_uint shouldBeAbleToDetachFromLibrary(jlc_lib* h) {

    printf("Should be able to detach from library");
    return jlc_lib_detach(h);
}

jlc_uint shouldBeAbleToOpenAThreadPool(jlc_lib h, jlc_tpool* tp) {

    printf("Should be able to open a thread pool");
    return jlc_tpool_open(h, tp, 5, 0);
}

jlc_uint shouldBeAbleToCloseAThreadPool(jlc_tpool* tp) {

    printf("Should be able to close a thread pool");
    return jlc_tpool_close(tp, 1, 5000);
}

int main() {

    jlc_lib h;
    jlc_tpool tp;

    context("libjlc thread pool");
    if (shouldBeAbleToAttachToLibrary(&h) == 0) {

        passed();

        if (shouldBeAbleToOpenAThreadPool(h, &tp) == 0) {

            passed();

            if (shouldBeAbleToCloseAThreadPool(&tp) == 0) {

	        passed();

	    } else {

                failed();
	    }
        }

        if (shouldBeAbleToDetachFromLibrary(&h) == 0) {

            return passed();
        }
    }

    return failed();
}

